// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 26 julio 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// ATDT AntenaTelevisorDosTornillos
// El archivo dibuja una antena algo pasada de moda para radio-television, 
// para utilizar como auxiliar en el interior de las habitaciones cuando no se
// dispone de un sistema de mayor eficacia. Es compatible con POV-Ray 3.1.
//
// La macro principal no tiene parametros.   
// #macro ATDT_DefaultAntena( )
//
// Para poder mover los elementos, puede utilizar la siguiente macro.
// #macro ATDT_Antena( AnguloSintonizar, GiroTorre, AnguloElevacion,
//                        ExtensionDerecha, RotarDerecha,
//                        ExtensionIzquierda, RotarIzquierda )
//      AnguloSintonizar        : Angulo de rotacion de la perilla.
//              Valor por defecto 90.
//      GiroTorre               : Angulo de la torre de rotacion de la antena
//              esferica. Valor por defecto 10.
//      AnguloElevacion         : Angulo de elevacion de la antena esferica.
//              Valor por defecto 45.
//      ExtensionDerecha        : Grado de extension de la antena alargable derecha, 
//              menor a la unidad pero no cercano a cero. Valor por defecto 1.00.
//      RotarDerecha            : Vector de rotacion para la antena alargable derecha,
//              valor nulo apunta hacia el cenit. Valor por defecto <  0, 10, 30>.
//      ExtensionIzquierda      : Grado de extension de la antena alargable izquierda, 
//              menor a la unidad pero no cercano a cero. Valor por defecto 0.75.
//      RotarIzquierda          : Vector de rotacion para la antena alargable izquierda,
//              valor nulo apunta hacia el cenit. Valor por defecto < 10,  0,-20>.
//
// La siguiente macro permite modificar algunas caracteristicas.
// #macro ATDT_AntenaTelevisorDosTornillos( AnguloSintonizar, GiroTorre,
//                AnguloElevacion, ExtensionDerecha, RotarDerecha,
//                ExtensionIzquierda, RotarIzquierda, FrenteFundamental,
//                PrimerNivel, BordePrimerNivel, SegundoNivel,
//                TercerNivel, GruesoTercerNivel,
//                RadioEsferico, MaterialPrincipal, MaterialMarca,
//                MaterialEsferico, MaterialAntena )
//      AnguloSintonizar        : Angulo de rotacion de la perilla.
//              Valor por defecto 90.
//      GiroTorre               : Angulo de la torre de rotacion de la antena
//              esferica. Valor por defecto 10.
//      AnguloElevacion         : Angulo de elevacion de la antena esferica.
//              Valor por defecto 45.
//      ExtensionDerecha        : Grado de extension de la antena alargable derecha, 
//              menor a la unidad pero no cercano a cero. Valor por defecto 1.00.
//      RotarDerecha            : Vector de rotacion para la antena alargable derecha,
//              valor nulo apunta hacia el cenit. Valor por defecto <  0, 10, 30>.
//      ExtensionIzquierda      : Grado de extension de la antena alargable izquierda, 
//              menor a la unidad pero no cercano a cero. Valor por defecto 0.75.
//      RotarIzquierda          : Vector de rotacion para la antena alargable izquierda,
//              valor nulo apunta hacia el cenit. Valor por defecto < 10,  0,-20>.  
//      FrenteFundamental       : Referencia para el frente de la antena.
//              Valor por defecto 91*L.        
//      PrimerNivel             : Alto de la primera base de la antena.
//              Valor por defecto 6*L.
//      BordePrimerNivel        : Borde en exceso de la primera base de la antena 
//              y grueso de la antena. Valor por defecto 3*L.
//      SegundoNivel            : Alto de la segunda base para la torre de la antena.
//              Valor por defecto 24*L.
//      TercerNivel             : Alto de referencia para la torre inferior.
//              Valor por defecto 32*L.
//      GruesoTercerNivel       : Valor de referencia para el grosor de la base
//              de la torre superior. Valor por defecto 23*L.
//      RadioEsferico           : Valor de referencia para las caracteristicas 
//              de la antena esferica. Valor por defecto 400*L.
//      MaterialPrincipal       : Material principal para el objeto.
//              Valor por defecto ATDT_MaterialPrincipal.
//      MaterialMarca           : Material para la decoracion cercana a la perilla.
//              Valor por defecto ATDT_MaterialMarca.
//      MaterialEsferico           : Material adicional para la antena esferica.
//              Valor por defecto ATDT_MaterialEsferico.
//      MaterialAntena          : Material para la antena. 
//              Valor por defecto ATDT_MaterialAntena.
//      
// La antena sin las antenas alargables tiene las siguientes caracteristicas:
//      Alto            = 125*L.
//      Frente X        = 110*L.
//      Profundidad Z   = 100*L.
// Con las antenas el tamano crece notablemente. El frente mira hacia Z-, gravedad Y-.
// El objeto se encuentra casi centrado sobre el plano XZ.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare ATDT_DefaultMaterialPrincipal        
//      Material principal para el objeto.
// #declare ATDT_DefaultMaterialMarca          
//      Material para la decoracion cercana a la perilla.
// #declare ATDT_DefaultMaterialEsferico         
//      Material adicional para la antena esferica.
// #declare ATDT_DefaultMaterialAntena        
//      Material para la antena.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare ATDT_MaterialPrincipal                  = material { ... }        
//      Material principal para el objeto.
// #declare ATDT_MaterialMarca                      = material { ... }
//      Material para la decoracin cercana a la perilla.
// #declare ATDT_MaterialEsferico                   = material { ... }         
//      Material adicional para la antena esferica.
// #declare ATDT_MaterialAntena                     = material { ... }
//      Material para la antena.   
// #declare ATDT_ColorGrado                         = White;
//      Color a aplicar a las marcas del cilindro sintonizador.
//        
// Para colocarlo simplemente
// #include "ATDT.inc" 
// object { ATDT_DefaultAntena( ) }
//                                 
// Ejemplo con la macro de posicion
// #include "ATDT.inc"
// object { ATDT_Antena( 90, 10, 45, 1.00, <0,10,30>,0.75,<10,0,-20> ) }
// 
// Ejemplo con la macro detallada, mismo objeto default
// #include "ATDT.inc"   
// object                       {
//   ATDT_AntenaTelevisorDosTornillos( 90, 10, 45, 1.00, <0,10,30>,0.75,<10,0,-20>, 
//                      0.091, 0.006, 0.003, 0.024, 0.032, 0.023, 0.400,
//                      ATDT_MaterialPrincipal, ATDT_MaterialMarca,
//                      ATDT_MaterialEsferico, ATDT_MaterialAntena ) }
//        
// Con modificadores
// #include "ATDT.inc"
// #include "textures.inc"
// #declare ATDT_MaterialPrincipal   = material { textures { PinkAlabaster } }
// object        { ATDT_Antena( ) }
//
#include "colors.inc"

#declare ATDT_L                                 = 0.001;
#declare ATDT_ColorGrado                        = White;      
      
#declare ATDT_DefaultMaterialPrincipal          =
  material                                      {
    texture                                     {
      pigment                                   {
        Gray20
      }
    }
  }

#ifndef ( ATDT_MaterialPrincipal )
  #declare ATDT_MaterialPrincipal               =
                        ATDT_DefaultMaterialPrincipal
#end  // #ifndef ( ATDT_MaterialPrincipal )

#declare ATDT_DefaultMaterialMarca              =
  material                                      {
    texture                                     {
      pigment                                   {
        onion
        frequency 10
        color_map               {
          [0.0 White]
          [0.1 White]
          [0.1 Blue]
          [1.0 Blue]
        }
      }
    }
  }

#ifndef ( ATDT_MaterialMarca )
  #declare ATDT_MaterialMarca                   =
                        ATDT_DefaultMaterialMarca
#end  // #ifndef ( ATDT_MaterialMarca )

#declare ATDT_DefaultMaterialEsferico           =
  material                                      {
    texture                                     {
      pigment                                   {
        color Gray20 transmit 0.8
      }
    }
  }

#ifndef ( ATDT_MaterialEsferico )
  #declare ATDT_MaterialEsferico                =
                        ATDT_DefaultMaterialEsferico
#end  // #ifndef ( ATDT_MaterialEsferico )

#declare ATDT_DefaultMaterialAntena             =
  material                                      {
    texture                                     {
      pigment                                   {
        color Silver
      }
      finish                                    {
        phong 0.2
      }
    }
  }

#ifndef ( ATDT_MaterialAntena )
  #declare ATDT_MaterialAntena                  =
                        ATDT_DefaultMaterialAntena
#end  // #ifndef ( ATDT_MaterialAntena )

#macro ATDT_AntenaTelevisorDosTornillos( AnguloSintonizar, GiroTorre,
                AnguloElevacion, ExtensionDerecha, RotarDerecha,
                ExtensionIzquierda, RotarIzquierda, FrenteFundamental,
                PrimerNivel, BordePrimerNivel, SegundoNivel,
                TercerNivel, GruesoTercerNivel, RadioEsferico,
                MaterialPrincipal, MaterialMarca,
                MaterialEsferico, MaterialAntena )
  union                                         {
    // Para seccion antena inicial
    #local LargoVarita                        = 1.5*TercerNivel;
    #local GruesoVarita                       = 0.4*BordePrimerNivel;
    superellipsoid                              {
      <0.05,0.05>
      scale             < FrenteFundamental/2, PrimerNivel/2, FrenteFundamental/2 >
      translate                 PrimerNivel/2*y
    }
    // SegundoNivel
    union                                       {
      // Forma SegundoNivel
      difference                                {
        #local A1                               = 0.5;
        #local A2                               = 0.975;
        #local B1                               = 0.2;
        #local AnguloPerilla              =
                  atan2( ( 1-B1 )*SegundoNivel,
                  ( A2-A1 )*( FrenteFundamental-BordePrimerNivel ) );
        #local AnguloPerillaD             = degrees( AnguloPerilla );
        #local RadioCilindro            = 0.3*( A2-A1 )*FrenteFundamental;
        prism                                   {
          -0.5,0.5,7
          <0,0>,
          <0.025,0.85>,
          <0.35,0.85>,
          <0.375,1.0>,
          <A1,1.0>,
          <A2,B1>,
          <1.0,0.0>
          rotate                                -90*x
          rotate                                90*y
          translate                             0.5*z
          scale < FrenteFundamental-BordePrimerNivel,
                  SegundoNivel,
                  FrenteFundamental-BordePrimerNivel >
        }
        box                                     {
          -1,1
          material                              {
            MaterialMarca
          }
          scale <0.2*( FrenteFundamental-BordePrimerNivel),0.05*PrimerNivel,
                        RadioCilindro>
          translate     -0.25*( FrenteFundamental-BordePrimerNivel )*x
          rotate                          -AnguloPerillaD*x
          translate     -( 0.5*A1+0.5*A2-0.5 )*FrenteFundamental*z
                        +( 0.5+0.5*B1 )*SegundoNivel*y
        }
        box                                     {
          <-FrenteFundamental,0.4*SegundoNivel-GruesoVarita,
            -1.5*GruesoVarita >,
          <-0.45*( FrenteFundamental-BordePrimerNivel )+2*GruesoVarita,
            1.1*SegundoNivel, +1.5*GruesoVarita >
          translate                     PrimerNivel*y
          translate                     0.25*( FrenteFundamental-BordePrimerNivel )*z
          material { MaterialAntena }
        }
        box                                     {
          <+FrenteFundamental,0.4*SegundoNivel-GruesoVarita,
            -1.5*GruesoVarita >,
          <+0.45*( FrenteFundamental-BordePrimerNivel )+2*GruesoVarita,
            1.1*SegundoNivel, +1.5*GruesoVarita >
          translate                     PrimerNivel*y
          translate                     0.25*( FrenteFundamental-BordePrimerNivel )*z
          material { MaterialAntena }
        }
      }  // END FormaSegundoNivel
      // Perilla
      union                                     {
        intersection                            {
          cylinder                              {
            0, SegundoNivel*y, RadioCilindro
          }
          union                                 {
            cylinder                            {
              0, 0.025*PrimerNivel*y, RadioCilindro
            }
            box                                 {
              <-RadioCilindro,0            ,-0.15*RadioCilindro>,
              <+RadioCilindro,0.1*PrimerNivel,+0.15*RadioCilindro>
            }
            box                                 {
              <-0.70*RadioCilindro,0            ,-0.15*RadioCilindro>,
              <+0.70*RadioCilindro,PrimerNivel,+0.15*RadioCilindro>
            }
          }
          rotate                        AnguloSintonizar*y
        }
        #local C                                = 0;
        #while ( C < 12 )
          cylinder                              {
            0.0125*PrimerNivel*y,-0.1*PrimerNivel*y,0.05*RadioCilindro
            translate                   1.1*RadioCilindro*x
            rotate                      360*C*y/12
            pigment { ATDT_ColorGrado }
          }
          #local C                              = C+1;
        #end  // #while ( C < 12 )
        rotate                          -AnguloPerillaD*x
        translate     -( 0.5*A1+0.5*A2-0.5 )*FrenteFundamental*z
                      +( 0.5+0.5*B1 )*SegundoNivel*y
                      +0.25*FrenteFundamental*x
      } // END Perilla
      // Antenas
      #local C                                  = 0;
      #while ( C < 2 )
        union                                   {
          sphere                                {
            0, 2*GruesoVarita
          }
          #local D                              = 0;
          #while ( D < 5 )
            cylinder                              {
              0, LargoVarita*y, GruesoVarita*( 1-0.2*D )
              #if ( C = 0 )
                translate D*0.90*ExtensionDerecha*LargoVarita*y
              #else
                translate D*0.90*ExtensionIzquierda*LargoVarita*y
              #end
            }
            #local D                            = D+1;
          #end  // #while ( D < 5 )
          cylinder                              {
            0, 0.0125*LargoVarita*y, 2*GruesoVarita
            #if ( C = 0 )
              translate           ( 1+3.6*ExtensionDerecha )*LargoVarita*y
            #else
              translate           ( 1+3.6*ExtensionIzquierda )*LargoVarita*y
            #end
          }
          #if ( C = 0 )
            rotate                              RotarDerecha
            translate    -0.45*( FrenteFundamental-BordePrimerNivel )*x
          #else  // #else ( C = 0 )
            rotate                              RotarIzquierda
            translate    +0.45*( FrenteFundamental-BordePrimerNivel )*x
          #end   // #else ( C = 0 )
          translate             0.4*SegundoNivel*y
          translate             +0.25*( FrenteFundamental-BordePrimerNivel )*z
          material                              {
            MaterialAntena
          }
        }
        #local C                                = C+1;
      #end  // #while ( C < 2 )
      // END Antenas
      translate                 PrimerNivel*y
    }  // END SegundoNivel
    // TercerNivel
    #local FactorTercerNivel    =
        ( FrenteFundamental-BordePrimerNivel )*A1-GruesoTercerNivel;
    #local FactorTercerNivel    = FactorTercerNivel/GruesoTercerNivel;
    prism                                       {
      conic_sweep
      linear_spline
      1, 1+FactorTercerNivel, 4
      <-0.5,-0.5>,
      <-0.5,+0.5>,
      <+0.5,+0.5>,
      <+0.5,-0.5>
      translate                 -y
      scale                     <1,-1/FactorTercerNivel,1>
      scale     <GruesoTercerNivel,(TercerNivel+SegundoNivel),GruesoTercerNivel>
      translate                 ( PrimerNivel+SegundoNivel+TercerNivel )*y
      translate                 +0.25*( FrenteFundamental-BordePrimerNivel )*z
    }  // END TercerNivel
    // Torre
    #local GruesoTorre          = 18*GruesoTercerNivel/23;
    #local AltoInicialTorre     = GruesoTorre;
    union                                       {
      #local FactorTorre        =
        2*( GruesoTercerNivel-GruesoTorre )/GruesoTercerNivel;
      intersection                              {
        prism                                   {
          conic_sweep
          linear_spline
          1-FactorTorre, 1, 4
          <-0.5,-0.5>,
          <-0.5,+0.5>,
          <+0.5,+0.5>,
          <+0.5,-0.5>
          translate                       -y
          scale                           <1,-1/FactorTorre,1>
          scale           < GruesoTercerNivel, 2*AltoInicialTorre, GruesoTercerNivel >
        }
        union                                   {
          box                                   {
            <-GruesoTercerNivel/2,0,-GruesoTercerNivel/2>,
            <+GruesoTercerNivel/2,AltoInicialTorre,+GruesoTercerNivel>
          }
          cylinder                              {
            -GruesoTercerNivel*x, +GruesoTercerNivel*x, GruesoTorre/2
            translate                   AltoInicialTorre*y
          }
        }
      }
      // SoporteEsferico
      union                                     {
        difference                              {
          box                                   {
            <-0.4*GruesoTorre,0.2*GruesoTorre,+0.4*GruesoTorre>,
            <+0.4*GruesoTorre,1.4*GruesoTorre,-1.0*GruesoTorre>
          }
        }
        #local Casquete                         =
          intersection                          {
            difference                          {
              sphere                            {
                0, RadioEsferico
              }
              plane                             {
                z, 0
              }
            }
            cylinder                            {
              -RadioEsferico*z, RadioEsferico*z, RadioEsferico
              scale             < 0.2,0.10,1>
            }
            cylinder                            {
              -RadioEsferico*z, RadioEsferico*z, RadioEsferico
              scale             < 0.15,0.8,1>
            }
          }
        union                                   {
          difference                            {
            object                              {
              Casquete
            }
            object                              {
              Casquete
              scale                     <1.005,1.005,0.995>
            }
            material                            {
              MaterialEsferico
            }
          }
          difference                            {
            object                              {
              Casquete
            }
            object                              {
              Casquete
              scale                     <1.005,1.005,0.990>
            }
            object                              {
              Casquete
              scale                     <0.990,0.995,1.005>
            }
          }
          intersection                          {
            object                              {
              Casquete
            }
            difference                          {
              cylinder                            {
                -0.0125*RadioEsferico*y,+0.0125*RadioEsferico*y,
                RadioEsferico
              }
              cylinder                            {
                -0.06*RadioEsferico*y,+0.06*RadioEsferico*y,
                0.99*RadioEsferico
              }
            }
          }
          cone                                  {
            0, 0.0125*RadioEsferico,
            -0.06*RadioEsferico*z, 0.005*RadioEsferico
            translate           +RadioEsferico*z
          }
          
          translate             0.7*GruesoTorre*y
                                -GruesoTorre*z-RadioEsferico*z
        }
        rotate                                  +AnguloElevacion*x
        translate                               AltoInicialTorre*y
      }  // END SoporteEsferico
      rotate                          GiroTorre*y
      translate                 ( PrimerNivel+SegundoNivel+TercerNivel )*y
      translate                 +0.25*( FrenteFundamental-BordePrimerNivel )*z
    }  // END Torre
    material                                    {
      MaterialPrincipal
    }
  }
#end  // #macro ATDT_AntenaTelevisorDosTornillos( )

#macro ATDT_Antena( AnguloSintonizar, GiroTorre, AnguloElevacion,
                        ExtensionDerecha, RotarDerecha,
                        ExtensionIzquierda, RotarIzquierda )
  object                                        {
    #local L                                    = ATDT_L;
    #local FrenteFundamental                    =  91*L;
    #local PrimerNivel                          =   6*L;
    #local BordePrimerNivel                     =   3*L;
    #local SegundoNivel                         =  24*L;
    #local TercerNivel                          =  32*L;
    #local GruesoTercerNivel                    =  23*L;
    #local RadioEsferico                        = 400*L;
    ATDT_AntenaTelevisorDosTornillos
          ( AnguloSintonizar, GiroTorre, AnguloElevacion,
            ExtensionDerecha, RotarDerecha,
            ExtensionIzquierda, RotarIzquierda,
            FrenteFundamental, PrimerNivel,
            BordePrimerNivel, SegundoNivel,
            TercerNivel, GruesoTercerNivel,
            RadioEsferico,
            ATDT_MaterialPrincipal, ATDT_MaterialMarca,
            ATDT_MaterialEsferico, ATDT_MaterialAntena )
  }
#end  // #macro ATDT_Antena( )     

#macro ATDT_DefaultAntena()        
  object                                        {
    #local AnguloSintonizar                     =  90;
    #local GiroTorre                            =  10;
    #local AnguloElevacion                      =  45;
    #local ExtensionDerecha                     =   1.00;
    #local RotarDerecha                         = <  0, 10, 30 >;
    #local ExtensionIzquierda                   =   0.75;
    #local RotarIzquierda                       = < 10,  0,-20 >;  
    ATDT_Antena( AnguloSintonizar, GiroTorre, AnguloElevacion,
                        ExtensionDerecha, RotarDerecha,
                        ExtensionIzquierda, RotarIzquierda )
  }
#end  // #macro ATDT_DefaultAntena()
