// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 19 abril 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// CAMD CaminadoraAereaMayoresDoce
// El archivo dibuja una caminadora aerea, similar a las que
// se encuentran actualmente en algunos parques publicos de Costa Rica.
//
// La macro principal tiene dos parametros. 
// #macro CAMD_Caminadora( AnguloPieDerecho, AnguloPieIzquierdo )   
//      AnguloPieDerecho        : Angulo de rotacion para el soporte de pie derecho de
//              usuario. Valores positivos giran hacia el frente del aparato.
//      AnguloPieIzquierdo      : Angulo de rotacion para el soporte de pie izquierdo de
//              usuario. Valores positivos giran hacia el frente del aparato.
//
// La siguiente macro permite modificar algunas caracteristicas.
// #macro CAMD_CaminadoraAereaMayoresDoce( AnguloPieDerecho, AnguloPieIzquierdo,
//                AltoFundamental, FrenteFundamental, ProfundidadFundamental,
//                AnguloAgarradera, DiametroSoporte, DiametroFundamental, 
//                SobreSuelo, CurvaturaSoporte,
//                TexturaPrincipal, TexturaDinamica,
//                TexturaSoporte, TexturaDecorativa, TexturaSujetador )
//      AnguloPieDerecho        : Angulo de rotacion para el soporte de pie derecho de
//              usuario. Valores positivos giran hacia el frente del aparato.
//      AnguloPieIzquierdo      : Angulo de rotacion para el soporte de pie izquierdo de
//              usuario. Valores positivos giran hacia el frente del aparato.  
//      AltoFundamental         : Alto de referencia para la caminadora.
//              Valor por defecto 1000*L.
//      FrenteFundamental       : Valor de referencia para el frente X de la caminadora.
//              Valor por defecto 670*L.
//      ProfundidadFundamental  : Valor de referencia para la profundidad Z de la caminadora.
//              Valor por defecto 250*L.
//      AnguloAgarradera        : Angulo de inclinacion en grados para el soporte 
//              de las manos.  Valor por defecto 25.   
//      DiametroSoporte         : Diametro de los cilindros principales de la estructura.
//              Valor por defecto 100*L.
//      DiametroDinamico        : Diametro para los cilindros movibles de la estructura.
//              Valor por defecto 34*L.
//      SobreSuelo              : Elevacion sobre el suelo del cilindro soporte.
//              Valor por defecto 100*L.
//      CurvaturaSoporte        : Valor para la curvatura como radio de los arcos
//              en las laterales.  Valor por defecto 150*L. 
//      TexturaPrincipal        : Textura principal a aplicar en la estructura.
//              Valor por defecto CAMD_TexturaPrincipal.
//      TexturaDinamica         : Textura de la caminadora aerea propiamente.
//              Valor por defecto CAMD_TexturaDinamica.
//      TexturaSoporte          : Textura de la base inferior.
//              Valor por defecto CAMD_TexturaSoporte.
//      TexturaDecorativa       : Textura para decoracion de los extremos del soporte.
//              Valor por defecto CAMD_TexturaDecorativa.
//      TexturaSujetador        : Textura de los aros metalicos para sujetar
//              la caminadora a la estructura.  Valor por defecto CAMD_TexturaSujetador.
//      
// La caminadora con parametros nulos se encuentra completamente contenida
// en las siguientes coordenadas.
//      Minimo  = < -336,    0, -267 >*L
//      Maximo  = <  336, 1153,  105 >*L  
// Frente mira hacia Z-, gravedad Y-. El cilindro central alineado con el origen del
// plano XZ.
//
// Estas son variables predefinidas o generadas en el
// interna de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare CAMD_DefaultTexturaPrincipal        
//      Textura principal a aplicar en la estructura.
// #declare cAMD_DefaultTexturaDinamica         
//      Textura de la caminadora aerea propiamente.
// #declare CAMD_DefaultTexturaSoporte          
//      Textura de la base inferior.
// #declare CAMD_DefaultTexturaDecorativa       
//      Textura para decoracion de los extremos del soporte.
// #declare CAMD_DefaultTexturaSujetador        
//      Textura de los aros metalicos para sujetar
//      la caminadora a la estructura.  
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare CAMD_TexturaPrincipal                   = texture { ... }        
//      Textura principal a aplicar en la estructura.
// #declare cAMD_TexturaDinamica                    = texture { ... }         
//      Textura de la caminadora aerea propiamente.
// #declare CAMD_TexturaSoporte                     = texture { ... }
//      Textura de la base inferior.
// #declare CAMD_TexturaDecorativa                  = texture { ... }
//      Textura para decoracion de los extremos del soporte.
// #declare CAMD_TexturaSujetador                   = texture { ... }
//      Textura de los aros metalicos para sujetar 
//      la caminadora a la estructura.  
//        
// Para colocarlo simplemente
// #include "CAMD.inc" 
// object { CAMD_Caminadora(0,0)
//                                  
// Ejemplo con la macro detallada, mismo objeto default
// #include "CAMD.inc"   
// object                       {
//   CAMD_CaminadoraAereaMayoresDoce( 0, 0, 
//              1.000, 0.670, 0.250, 25, 0.100, 0.034, 0.100, 0.150,
//              CAMD_TexturaPrincipal, CAMD_TexturaDinamica,
//              CAMD_TexturaSoporte, CAMD_TexturaDecorativa, CAMD_TexturaSujetador )
// }
//        
// Con modificadores
// #include "CAMD.inc"
// #include "textures.inc"
// #declare CAMD_TexturaPrincipal   = PinkAlabaster
// object        { CAMD_Caminadora(0,0) }
//
#if ( version >= 3.7 )
  #version 3.7; 
#end

global_settings { assumed_gamma 1.0 }

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}   
 
#include "CAMD.inc"
                                   
object                                  {
  CAMD_Caminadora( 1, -1 )  
  translate             -0.575*y
}

