// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 15 marzo 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// CUMP CortaUnasManoPie
// El archivo dibuja un cortauas para manos y pies corriente.
// Es muy poco flexible. Es compatible con POVRay 3.1.
//
// La macro principal tiene tres parametros. 
// #macro CUMP_CortaUnas( FraccionPrensa, AnguloLima, AnguloPrensa ) 
//      FraccionPrensa          : Fraccion propia entre -1.0 a 1.0. Valores positivos para prensar
//              el cortaunas, valores negativos para cerrarlo. -1.0 es completamente cerrado,
//              y 1.0 es presion maxima. Para cerrar complemente el cortaunas, deberia
//              asignar un valor 180 a AnguloPrensa.
//      AnguloLima              : Angulo para girar la lima de unas.
//      AnguloPrensa            : Angulo para girar la prensa cortante.
//
// La siguiente macro permite modificar las texturas desde los parametros.
// #macro CUMP_CortaUnasManoPie( FraccionPrensa, AnguloLima, AnguloPrensa,
//                  TexturaPrincipal, TexturaLima, TexturaPrensa )
//      FraccionPrensa          : Fraccion propia. Valores positivos para prensar
//              el cortaunas, valores negativos para cerrarlo. -1.0 es completamente cerrado,
//              y 1.0 es presion maxima. Para cerrar complemente el cortaunas, deberia
//              asignar un valor 180 a AnguloPrensa.
//      AnguloLima              : Angulo para girar la lima de unas.
//      AnguloPrensa            : Angulo para girar la prensa cortante. 
//      TexturaPrincipal        : Textura para aplicar al cuerpo principal.
//              Valor por defecto CUMP_TexturaPrincipal.
//      TexturaLima             : Textura para la lima.
//              Valor por defecto CUMP_TexturaLima.
//      TexturaPrensa           : Textura para la prensa de presion cortante.
//              Valor por defecto CUMP_TexturaPrensa.
//      
// El cortaunas cerrado con parametros (-1,0,180) se encuentra completamente contenido
// en las siguientes coordenadas.
//      Minimo  = <  -5,  -5,  -6 >*L
//      Maximo  = <  53,   8,   6 >*L  
// Frente mira hacia X+, gravedad Y-. El origen se ubica en una perforacion cilindrica
// que suele tener un collar metalico para colgar.
//
// Estas son variables predefinidas o generadas en el
// interna de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare CUMP_DefaultTexturaPrincipal  
//      Textura para aplicar al cuerpo principal.
// #declare CUMP_DefaultTexturaLima      
//      Textura para la lima.
// #declare CUMP_DefaultTexturaPrensa           
//      Textura para la prensa de presion cortante.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare CUMP_TexturaPrincipal               = texture { ... }                 
//      Textura para aplicar al cuerpo principal.
// #declare CUMP_TexturaLima                    = texture { ... }
//      Textura para la lima.                                   
// #declare CUMP_TexturaPrensa                  = texture { ... }
//      Textura para la prensa de presion cortante.
//        
// Para colocarlo simplemente
// #include "CUMP.inc" 
// object { CUMP_CortaUnas(0,0,0)
//                                  
// Ejemplo con la macro de texturas, mismo objeto default
// #include "CUMP.inc"   
// object                       {
//   CUMP_CortaUnasManoPie(0,0,0,
//      CUMP_TexturaPrincipal,CUMP_TexturaLima,CUMPT_TexturaPrensa)
// }
//        
// Con modificadores
// #include "CUMP.inc"
// #include "textures.inc"
// #declare CUMP_TexturaPrincipal   = PinkAlabaster
// object        { CUMP_CortaUnas(0,0,0) }
// 
#if ( version >= 3.7 )
  #version 3.7; 
#end

global_settings { assumed_gamma 1.0 }

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}   
 
#include "CUMP.inc"

#local FactorAcercamiento       = 30;                                   
                                   
object                                  {
  CUMP_CortaUnas( 0.0, 40.0, 0.0 )   
  translate       -0.025*x-0.010*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}

